         PRINT NOGEN
         BEGIN NAME=QZZ3,IBM=YES,TPFISOC=YES
***********************************************************************
*          Licensed Materials - Property of IBM                       *
*          "Restricted Materials of IBM"                              *
*          5748-T15                                                   *
*          (C) Copyright IBM Corp. 2005, 2019                         *
*          All Rights Reserved                                        *
*          US Government Users Restricted Rights - Use, duplication   *
*          or disclosure restricted by GSA ADP Schedule Contract      *
*          with IBM Corp.                                             *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
*  Change History                                                     *
*                                                                     *
* 20190115  d26048  XWB support                                       *
*                                                                     *
***********************************************************************
* GENERAL INFORMATION:                                                *
*                                                                     *
***********************************************************************
         PRLGC FRAMESIZE=WRKLGH,ENAME=OWN,BASE=NO
         PRINT NOGEN
         USING WRK,ICST_WRK
*
* Remove
         SGR R4,R4
         LG  R4,16(,R2)          Third parameter
         SGR R7,R7
         SGR R5,R5
         LG R7,8(,R2)            2nd param
         LG R5,0(,R2)            1st parameter
*        J HERE
* REMOVE
*
*
* Case statement
*
         SGR  R3,R3
         LA   R3,0
         CR   R5,R3
         JE   GSYSHEAP
         SGR  R3,R3
         LA   R3,1
         CR   R5,R3
         JE   GSWB
         SGR  R3,R3                                                     d26048
         LA   R3,8                                                      d26048
         CR   R5,R3                                                     d26048
         JE   GXWB                                                      d26048
         LA   R3,2
         CR   R5,R3
         JE   SECB
         LA   R3,3
         CR   R5,R3
         JE   GFRM4K
         LA   R3,4
         CR   R5,R3
         JE   GCMB
         LA   R3,5
         CR   R5,R3
         JE   GFRM1MB
         LA   R3,6
         CR   R5,R3
         JE   GOWNER
         LA   R3,7
         CR   R5,R3
         JE   GECB
         J    RETURN
* End Case
*
* BEGIN GSYSC MACRO TO HANDLE 4K FRM
*
GSYSHEAP LARL  R5,=C'MSYSHEAP'         System heap token
       GSYSC FRAMES=R4,TOKEN=R5,TYPE=1MB,OWNER=R7,HEAP=64BIT
         LA    R15,0                   NULL OUT REG15
         LTGR  R4,R4                   Were we successful?
         J     RETURN
*
* END GSYSC MACRO TO HANDLE 4K FRM
*
GSWB     SGR R4,R4
         GSWBC BLOCK=R4,OWNER=R7
         LA    R15,0                   NULL OUT REG15
         LTGR  R4,R4                   Were we successful?
         J     RETURN
*
GXWB     SGR R4,R4                                                      d26048
         GSWBC BLOCK=R4,OWNER=R7,USE=XWB                                d26048
         LA    R15,0                   NULL OUT REG15                   d26048
         LTGR  R4,R4                   Were we successful?              d26048
         J     RETURN                                                   d26048
*
SECB     EOWNRC FUNC=SET,OWNER=R7
         J     RETURN
GECB     EOWNRC FUNC=GET,OWNER=R7
         J     RETURN
*
* Owner requires a contant TYPE
*
GOWNER   LA   R3,0
         CR   R4,R3
         JE   GETOSH
         LA   R3,1
         CR   R4,R3
         JE   GETOSW
         LA   R3,3
         CR   R4,R3
         JE   GETOFR
         LA   R3,4
         CR   R4,R3
         JE   GETOCMB
         LA   R3,5
         CR   R4,R3
         JE   GETOF1
         LA   R3,6                                                      d26048
         CR   R4,R3                                                     d26048
         JE   GETOXW                                                    d26048
*
GETOSH   LA    R5,0
         OWNERC AREA=R4,OWNER=R7,BLOCK=SYSHEAP,HIGH=R5
         J     RETURN
GETOSW   LA    R5,0
         OWNERC AREA=R4,OWNER=R7,BLOCK=SWB,HIGH=R5
         J     RETURN
GETOXW   LA    R5,0                                                     d26048
         OWNERC AREA=R4,OWNER=R7,BLOCK=XWB,HIGH=R5                      d26048
         J     RETURN                                                   d26048
GETOFR   LA    R5,0
         OWNERC AREA=R4,OWNER=R7,BLOCK=FRM,HIGH=R5
         J     RETURN
GETOCMB  LA    R5,0
         OWNERC AREA=R4,OWNER=R7,BLOCK=CMB,HIGH=R5
         J     RETURN
GETOF1   LA    R5,0
         OWNERC AREA=R4,OWNER=R7,BLOCK=FRM1MB,HIGH=R5
         J     RETURN
*
* End Get OWNER
*
GCMB     SGR   R4,R4
         GETCC DA,L4,FILL=00,COMMON=YES
         J     RETURN
GFRM4K   SGR   R4,R4
         GETCC DA,L4,FILL=00,COMMON=NO
         J     RETURN
GFRM1MB LARL  R5,=C'ABCDECF'         System heap token
       GSYSC FRAMES=R4,TOKEN=R5,TYPE=1MB,OWNER=R7,HEAP=31BIT
         LA    R15,0                   NULL OUT REG15
         LTGR  R4,R4                   Were we successful?
         JZ    RETURN                  No, return.
         J     RETURN
*
FAIL     DS    0H
         LA    R4,0
         J     RETURN
RETURN   DS    0H
*
         LGR   R15,R4
         EPLGC RC=R15              Return system heap address
         LTORG ,
         DROP  ,
APPKEY   EQU   X'10'
         FINIS QZZ3
WRK      DSECT
         DS    XL(ICST_LEN)
         DS    0D
WRK_PSW  DS    XL16
TEST     DS    F
WRKLGH   EQU   *-WRK
         END   ,
